package kr.co.icontrols.ilp300_700.admin.test;

import android.content.Context;
import android.content.Intent;
import android.graphics.Color;
import android.util.Log;
import android.view.Gravity;
import android.view.KeyEvent;
import android.widget.RelativeLayout;

import kr.co.icontrols.ilp300_700.MainActivity;
import kr.co.icontrols.ilp300_700.R;
import kr.co.icontrols.ilp300_700.global.Configure.ConfigValue;
import kr.co.icontrols.ilp300_700.global.DataClasses.POSITION;
import kr.co.icontrols.ilp300_700.global.Declare;
import kr.co.icontrols.ilp300_700.global.ID;
import kr.co.icontrols.wallpadsupport.WpadImageView;
import kr.co.icontrols.wallpadsupport.WpadScreen;
import kr.co.icontrols.wallpadsupport.WpadTextView;

public class AdminSet_Test_TalkTestMode extends WpadScreen {

    String TAG = "AdminSet_Test_TalkTestMode";

    boolean bLOG = true;   // true, false
    boolean bLOG_DEBUG = true;   // true, false
    boolean bLOG_INFO = true;   // true, false
    Context mContext;
    WpadImageView Image_Background;
    WpadTextView Text_Title;
    WpadTextView Text_Line_01_Item;
    WpadTextView Text_Line_02_Item;
    WpadTextView Text_Line_03_Item;
    WpadTextView Text_Line_04_Item;
    int TextColor_Normal = Color.WHITE;
    int TextColor_Highlight = Color.WHITE;
    int nFontSize_Instruction = 28;
    int nFontSize_Instruction_Bottom = 20;
    boolean bFontNonBold = false;
    boolean bFontBold = true;
    String strText_Title = "통화시험모드";
    String strText_Line_01_Item = "1] 설정";
    String strText_Line_02_Item = "2] 해제";
    String strText_Line_03_Item = "통화시험모드 설정됨";
    String strText_Line_04_Item = "- 재부팅시 자동으로 해제됩니다. -";
    public AdminSet_Test_TalkTestMode(Context context, RelativeLayout layout) {
        super(context, layout);
        try {
            LOG("------------------ [START - AdminSet_Test_TalkTestMode] -------------------");

            mContext = context;
            Initialize();

            Image_Background = new WpadImageView(context, 0, Declare.DeviceInfo.getScreenSizeFullW(ConfigValue.DEVICE_MODELTYPE), Declare.DeviceInfo.getScreenSizeFullH(ConfigValue.DEVICE_MODELTYPE), R.drawable.bg_back, 0, ID.SCREENS.ADMINSET_TEST_TALKTESTMODE.ELEMENTS.IMAGES.BACKGROUND);
            ViewRegistration(layout, Image_Background, 0, 0);

            Text_Title = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_TEST_TALKTESTMODE.ELEMENTS.TEXTS.TITLE).W, getPosition(ID.SCREENS.ADMINSET_TEST_TALKTESTMODE.ELEMENTS.TEXTS.TITLE).H, Gravity.CENTER, TextColor_Normal, nFontSize_Instruction, bFontBold, ID.SCREENS.ADMINSET_TEST_TALKTESTMODE.ELEMENTS.TEXTS.TITLE);
            ViewRegistration(layout, Text_Title, getPosition(ID.SCREENS.ADMINSET_TEST_TALKTESTMODE.ELEMENTS.TEXTS.TITLE).X, getPosition(ID.SCREENS.ADMINSET_TEST_TALKTESTMODE.ELEMENTS.TEXTS.TITLE).Y);
            Text_Title.setText(strText_Title);

            Text_Line_01_Item = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_TEST_TALKTESTMODE.ELEMENTS.TEXTS.LINE_01_Item).W, getPosition(ID.SCREENS.ADMINSET_TEST_TALKTESTMODE.ELEMENTS.TEXTS.LINE_01_Item).H, Gravity.LEFT, TextColor_Normal, nFontSize_Instruction, bFontNonBold, ID.SCREENS.ADMINSET_TEST_TALKTESTMODE.ELEMENTS.TEXTS.LINE_01_Item);
            ViewRegistration(layout, Text_Line_01_Item, getPosition(ID.SCREENS.ADMINSET_TEST_TALKTESTMODE.ELEMENTS.TEXTS.LINE_01_Item).X, getPosition(ID.SCREENS.ADMINSET_TEST_TALKTESTMODE.ELEMENTS.TEXTS.LINE_01_Item).Y);
            Text_Line_01_Item.setText(strText_Line_01_Item);

            Text_Line_02_Item = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_TEST_TALKTESTMODE.ELEMENTS.TEXTS.LINE_02_Item).W, getPosition(ID.SCREENS.ADMINSET_TEST_TALKTESTMODE.ELEMENTS.TEXTS.LINE_02_Item).H, Gravity.LEFT, TextColor_Normal, nFontSize_Instruction, bFontNonBold, ID.SCREENS.ADMINSET_TEST_TALKTESTMODE.ELEMENTS.TEXTS.LINE_02_Item);
            ViewRegistration(layout, Text_Line_02_Item, getPosition(ID.SCREENS.ADMINSET_TEST_TALKTESTMODE.ELEMENTS.TEXTS.LINE_02_Item).X, getPosition(ID.SCREENS.ADMINSET_TEST_TALKTESTMODE.ELEMENTS.TEXTS.LINE_02_Item).Y);
            Text_Line_02_Item.setText(strText_Line_02_Item);

            Text_Line_03_Item = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_TEST_TALKTESTMODE.ELEMENTS.TEXTS.LINE_03_Item).W, getPosition(ID.SCREENS.ADMINSET_TEST_TALKTESTMODE.ELEMENTS.TEXTS.LINE_03_Item).H, Gravity.CENTER, TextColor_Highlight, nFontSize_Instruction, bFontNonBold, ID.SCREENS.ADMINSET_TEST_TALKTESTMODE.ELEMENTS.TEXTS.LINE_03_Item);
            ViewRegistration(layout, Text_Line_03_Item, getPosition(ID.SCREENS.ADMINSET_TEST_TALKTESTMODE.ELEMENTS.TEXTS.LINE_03_Item).X, getPosition(ID.SCREENS.ADMINSET_TEST_TALKTESTMODE.ELEMENTS.TEXTS.LINE_03_Item).Y);
            Text_Line_03_Item.setText(strText_Line_03_Item);

            Text_Line_04_Item = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_TEST_TALKTESTMODE.ELEMENTS.TEXTS.LINE_04_Item).W, getPosition(ID.SCREENS.ADMINSET_TEST_TALKTESTMODE.ELEMENTS.TEXTS.LINE_04_Item).H, Gravity.LEFT, TextColor_Normal, nFontSize_Instruction, bFontNonBold, ID.SCREENS.ADMINSET_TEST_TALKTESTMODE.ELEMENTS.TEXTS.LINE_04_Item);
            ViewRegistration(layout, Text_Line_04_Item, getPosition(ID.SCREENS.ADMINSET_TEST_TALKTESTMODE.ELEMENTS.TEXTS.LINE_04_Item).X, getPosition(ID.SCREENS.ADMINSET_TEST_TALKTESTMODE.ELEMENTS.TEXTS.LINE_04_Item).Y);
            Text_Line_04_Item.setText(strText_Line_04_Item);

            checkTestMode();
            ((MainActivity) mContext).setAutoScreenChange(ID.SCREENS.Main, MainActivity.nAdminScreenTimeout);
        } catch (Exception e) {
            Log.e(TAG, "[Exception] AdminSet_Test_TalkTestMode(...) : " + e);
            e.printStackTrace();
        }
    }

    private void LOG(String log) {
        if (bLOG) Log.v(TAG, log);
    }

    private void LOG_DEBUG(String log) {
        if (bLOG_DEBUG) Log.d(TAG, log);
    }

    private void LOG_INFO(String log) {
        if (bLOG_INFO) Log.i(TAG, log);
    }

    protected void Initialize() {
        try {
            LOG("[Initialize] Start!!");
        } catch (Exception e) {
            Log.e(TAG, "[Exception] Initialize() : " + e);
            e.printStackTrace();
        }
    }

    @Override
    protected void onClose() {
        try {
            LOG("------------------ [onClose - AdminSet_Test_TalkTestMode] -------------------");
        } catch (Exception e) {
            Log.e(TAG, "[Exception] onClose() : " + e);
            e.printStackTrace();
        }
        super.onClose();
    }

    @Override
    protected void onBrReceive(Intent intent) {
        try {
            LOG("[onBrReceive] Intent : " + intent);
        } catch (Exception e) {
            Log.e(TAG, "[Exception] onBrReceive(...) : " + e);
            e.printStackTrace();
        }
        super.onBrReceive(intent);
    }

    @Override
    protected void onKeyDown(int keyCode, KeyEvent event) {
        try {
            if (keyCode == Declare.Button.NUMBER_01) {
                MainActivity.mCallController.bTalkTestModeEnable = true;
                MainActivity.mCallController.mCTT.setTalkTestMode();
                MainActivity.mSound.PlayMent_lobby(R.raw.setting);
                super.setChangeScreen(ID.SCREENS.AdminSet_Test);
            } else if (keyCode == Declare.Button.NUMBER_02) {
                MainActivity.mCallController.bTalkTestModeEnable = false;
                MainActivity.mCallController.mCTT.setTalkNormalMode();
                MainActivity.mSound.PlayMent_lobby(R.raw.setting);
                super.setChangeScreen(ID.SCREENS.AdminSet_Test);
            } else if (keyCode == Declare.Button.CANCEL || keyCode == Declare.Button.TACT_CANCEL) {
                super.setChangeScreen(ID.SCREENS.AdminSet_Test);
            }
        } catch (Exception e) {
            Log.e(TAG, "[Exception] onKeyDown(...) : " + e);
            e.printStackTrace();
        }
        super.onKeyDown(keyCode, event);
    }

    public POSITION getPosition(int nID) {
        POSITION position = new POSITION();
        position.SetPosition(0, 0, 480, 272);
        try {
            switch (nID) {
                case ID.SCREENS.ADMINSET_TEST_TALKTESTMODE.ELEMENTS.IMAGES.BACKGROUND:
                    position.SetPosition(0, 0, 480, 272);
                    return position;

                case ID.SCREENS.ADMINSET_TEST_TALKTESTMODE.ELEMENTS.TEXTS.TITLE:
                    position.SetPosition(0, 24, 480, 40);
                    return position;

                case ID.SCREENS.ADMINSET_TEST_TALKTESTMODE.ELEMENTS.TEXTS.LINE_01_Item:
                    position.SetPosition(30, 73, 450, 40);
                    return position;

                case ID.SCREENS.ADMINSET_TEST_TALKTESTMODE.ELEMENTS.TEXTS.LINE_02_Item:
                    position.SetPosition(30, 122, 450, 40);
                    return position;

                case ID.SCREENS.ADMINSET_TEST_TALKTESTMODE.ELEMENTS.TEXTS.LINE_03_Item:
                    position.SetPosition(30, 171, 450, 40);
                    return position;

                case ID.SCREENS.ADMINSET_TEST_TALKTESTMODE.ELEMENTS.TEXTS.LINE_04_Item:
                    position.SetPosition(30, 220, 450, 40);
                    return position;

                default:
                    return position;
            }
        } catch (Exception e) {
            Log.e(TAG, "[Exception] getPosition() : " + e);
            e.printStackTrace();
            return position;
        }
    }

    private void checkTestMode() {
        try {
            if (MainActivity.mCallController.bTalkTestModeEnable) {
                Text_Line_03_Item.setTextColor(Color.GREEN);
                Text_Line_03_Item.setText("통화시험모드 설정됨");
            } else {
                Text_Line_03_Item.setTextColor(Color.WHITE);
                Text_Line_03_Item.setText("통화시험모드 해제됨");
            }
        } catch (Exception e) {
            Log.e(TAG, "[Exception] checkTestMode() : " + e);
            e.printStackTrace();
        }
    }

}